summaryrefslogtreecommitdiffstats
path: root/package/base-files/default/sbin
diff options
context:
space:
mode:
authornbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-10-22 20:47:19 +0000
committernbd <nbd@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-10-22 20:47:19 +0000
commit15713b2da9a57d19a4b04af0dd77362c92979966 (patch)
treedc5e3fa715e87b8d2c61e3e3fb71b5f4e6268c10 /package/base-files/default/sbin
parent3c8c1d5d8129266fead520436949c40d62813d1f (diff)
sync base-files with whiterussian
git-svn-id: svn://svn.openwrt.org/openwrt/trunk/openwrt@2260 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'package/base-files/default/sbin')
-rwxr-xr-xpackage/base-files/default/sbin/ifdown6
-rwxr-xr-xpackage/base-files/default/sbin/ifup82
2 files changed, 30 insertions, 58 deletions
diff --git a/package/base-files/default/sbin/ifdown b/package/base-files/default/sbin/ifdown
index 2d4054d8b..147136949 100755
--- a/package/base-files/default/sbin/ifdown
+++ b/package/base-files/default/sbin/ifdown
@@ -6,6 +6,8 @@
type=$1
debug "### ifdown $type ###"
if=$(nvram get ${type}_ifname)
-if_valid $if || exit
-$DEBUG ifconfig $if down
+proto=$(nvram get ${type}_proto)
+if_valid $if && $DEBUG ifconfig $if down
kill $(cat /var/run/${if}.pid 2>&-) 2>&-
+[ "$if" = "ppp0" ] && killall pppd
+killall ifup.$proto >&- 2>&-
diff --git a/package/base-files/default/sbin/ifup b/package/base-files/default/sbin/ifup
index 1f78061a2..be7075bf1 100755
--- a/package/base-files/default/sbin/ifup
+++ b/package/base-files/default/sbin/ifup
@@ -1,5 +1,6 @@
#!/bin/ash
[ $# = 0 ] && { echo " $0 <group>"; exit; }
+
. /etc/functions.sh
. /etc/network.overrides
[ "$FAILSAFE" != "true" -a -e /etc/config/network ] && . /etc/config/network
@@ -8,59 +9,28 @@ type=$1
debug "### ifup $type ###"
if_proto=$(nvram get ${type}_proto)
-[ "${if_proto}" = "pppoa" ] || {
- if=$(nvram get ${type}_ifname)
- [ "${if%%[0-9]}" = "ppp" ] && if=$(nvram get ${if_proto}_ifname)
-
- if_valid $if || exit
- mac=$(nvram get ${type}_hwaddr)
- $DEBUG ifconfig $if down 2>&-
-
- pidfile=/var/run/${if}.pid
- [ -f $pidfile ] && $DEBUG kill $(cat $pidfile)
-
- if [ "${if%%[0-9]}" = "br" ]; then
- stp=$(nvram get ${type}_stp)
- $DEBUG brctl delbr $if 2>&-
- $DEBUG brctl addbr $if
- $DEBUG brctl setfd $if 0
- $DEBUG brctl stp $if ${stp:-0}
-
- for sif in $(nvram get ${type}_ifnames); do
- if_valid $sif || continue
- ${mac:+$DEBUG ifconfig $sif down hw ether $mac}
- $DEBUG ifconfig $sif 0.0.0.0 up
- $DEBUG brctl addif $if $sif
- done
- else
- ${mac:+$DEBUG ifconfig $if down hw ether $mac}
- fi
-}
-
-case "$if_proto" in
- static)
- ip=$(nvram get ${type}_ipaddr)
- netmask=$(nvram get ${type}_netmask)
- gateway=$(nvram get ${type}_gateway)
-
- $DEBUG ifconfig $if $ip ${netmask:+netmask $netmask} broadcast + up
- ${gateway:+$DEBUG route add default gw $gateway}
-
- [ -f /etc/resolv.conf ] && return
-
- debug "# --- creating /etc/resolv.conf ---"
- for dns in $(nvram get ${type}_dns); do
- echo "nameserver $dns" >> /etc/resolv.conf
- done
- ;;
- dhcp)
- ip=$(nvram get ${type}_ipaddr)
- ${DEBUG:-eval} "udhcpc -R -i $if ${ip:+-r $ip} -b -p $pidfile &"
- ;;
- none|"")
- ;;
- *)
- [ -x "/sbin/ifup.${if_proto}" ] && { $DEBUG /sbin/ifup.${if_proto} $*; exit; }
- echo "### ifup $type: ignored ${type}_proto=\"$if_proto\" (not supported)"
- ;;
-esac
+if=$(nvram get ${type}_ifname)
+[ "${if%%[0-9]}" = "ppp" ] && if=$(nvram get ${if_proto}_ifname)
+
+if_valid $if || [ "$if_proto" = "pptp" ] || exit
+mac=$(nvram get ${type}_hwaddr)
+$DEBUG ifconfig $if down 2>&-
+
+if [ "${if%%[0-9]}" = "br" ]; then
+ stp=$(nvram get ${type}_stp)
+ $DEBUG brctl delbr $if 2>&-
+ $DEBUG brctl addbr $if
+ $DEBUG brctl setfd $if 0
+ $DEBUG brctl stp $if ${stp:-0}
+
+ for sif in $(nvram get ${type}_ifnames); do
+ if_valid $sif || continue
+ ${mac:+$DEBUG ifconfig $sif down hw ether $mac}
+ $DEBUG ifconfig $sif 0.0.0.0 up
+ $DEBUG brctl addif $if $sif
+ done
+else
+ ${mac:+$DEBUG ifconfig $if down hw ether $mac}
+fi
+
+do_ifup $if_proto $type